<?php

/*
 * Simple server-side script that, in response to an appropriate HTTP request,
 * returns a list of the available presentations, if any, for a particular 
 * avatar (whose name is provided, with an underscore between first and second 
 * names, as a POST argument to the script). It is assumed that this argument
 * will correspond to the name of a directory in the current working directory;
 * and that this directory will contain further directories, each 
 * corresponding to one of the avatar's available presentations. The name of
 * each such sub-directory will be returned on a separate line by this script.
 * If there is no directory corresponding to the avatar, or if that directory
 * is empty, this script returns nothing. 
 * 
 * Note that this script is intended to be called from a Second Life LSL
 * script (within an object such as a screen, say) that generates the
 * appropriate HTTP request.
 *
 */

	$avatar=$_POST['avatar']; // get avatar name from POST info.
	$presents = array();

  	if (is_dir($avatar)) 
	{
    		// found directory, now look at contents:
    		$mDir=opendir($avatar);
    		while (false !== ($ifile = readdir($mDir))) 
		{
      			if(!($ifile == "." || $ifile == ".."))
			{
        			//print $ifile."\n";
				$presents[] = $ifile;
      			}
    		}
  	}

	if(sizeof($presents)>0)
	{
		natcasesort($presents);
		foreach ($presents as $key => $val) 
		{
			print $val."\n";
		}
	}


?>
