<?php
/* 
 * Simple server-side script that, in response to an appropriate HTTP request,
 * returns a summary of the contents of a particular directory, assumed to 
 * contain a set of image files (jpg, gif, png) that constitute a presentation. 
 * The request should have two arguments; it is assumed that the directory in 
 * question is <arg1>/<arg2> relative to the current working directory. It is 
 * also assumed that the names of the image files in this directory share a 
 * common root element, suffixed with a number (corresponding to their relative
 * position in the presentation) and the file extension. Finally, it is assumed
 * that all image files are of the same type (= same extension).
 * 
 * Note that this script is intended to be called from a Second Life LSL
 * script (within an object such as a screen, say) that generates the
 * appropriate HTTP request. Typically, the first argument will correspond
 * to the name of an avatar (which an underscore joining first and second
 * names) and the second argument will correspond to the name of a presentation
 * (again, underscored).
 *
 * The returned summary of the contents of the directory has the following
 * form (each on a newline):
 * - relative path to presentation + the root name of image files (=name up to
 * numerical index; assumes that files are named as <root><index>.<extension>
 * where <index> = some integer.
 * - type of images (= file extension)
 * - the index of the first image (in its file name)
 * - total number of images in directory
 */


	$avatar_dir=$_POST['avatar'];
	$pres_dir=$_POST['present'];

  	$presentation_dir = './'.$avatar_dir.'/'.$pres_dir;
	$filetype = '';
	$filebase = '';
  	if (is_dir($presentation_dir)) 
	{
    		// found directory, now look at contents:
    		$mDir=opendir($presentation_dir);
    		$slidecount = 0;
		//$startslide = 0; // index of the name of first slide 
    		$slidename = '';
		$pi;
    		while (false !== ($ifile = readdir($mDir)))
		{
			$pi = pathinfo($ifile);
			$extension = strtolower($pi['extension']);
			if($extension == "jpg" 
				|| $extension == "jpeg" 
				|| $extension == "png" 
				|| $extension == "gif"
				|| $extension == "html")
			{
				$filetype = $extension;
				$filebase = $pi['basename'];
				/*
				// can't assume this returns slides in order!
				$match = array();
				// extract index of the slide:
				if(preg_match("/(\d{1,3}?)[.]/", $ifile, $match))
				{
					print_r($match);

					if($slidecount==0)
					{ 
						$startslide = $match[1];
					}
					else if($match[1]<$startslide)
					{
						$startslide = $match[1];
					}
				}
				*/
        			$slidecount++;
      			}
    		}

		// split the file basename around digits+full stop:
		//$regm = preg_split("/\d{1,3}?[.]/", $pi['basename']);
		$regm = preg_split("/\d{1,3}?[.]/", $filebase);

		// print path + root file name:
    		print $avatar_dir.'/'.$pres_dir.'/'.$regm[0]."\n";

		// print extension:
		//print $pi['extension']."\n";
		print $filetype."\n";

		// print index of first slide:
		// print $startslide."\n";

		// print number of slides:
    		print $slidecount."\n";
  	}

?>
